#ifndef _TCallbackOD_HPP_
#define _TCallbackOD_HPP_
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/******************************************************************************
 *
 * Source File Name = TCallbackOD.HPP
 *
 * TCallbackOD - an class that represents a callback
 *               for OD
 *
 *****************************************************************************/
#include <DKString.hpp>
#include <dkCallback.hpp>
#include <DKConstantOD.hpp>
#include <DKSynonym.hpp>
#include <DKDDO.hpp>
#include <dkXDO.hpp>
#include <DKSequentialCollection.hpp>
#include <DKException.hpp>
#include "DKDatastoreOD.hpp"

class TCallbackOD : public dkCallback
{
  public:
   TCallbackOD(DKDatastoreOD* dsOD,
               long           thresholdValue,
               long           iterationsValue,
               BOOL           retrieveHits);
   virtual ~TCallbackOD();
   DKBoolean isDone();
   void setThreshold(long nValue);
   long getThreshold();
   void cancelQuery();
   DKBoolean dataCallback(dkCollection* ddoList, DKBoolean isDone);
   void retrieveDDO();

   void reportException(DKException* exc);
   DKException* getException();
   void resetException();

  private:
   DKDatastoreOD* _dsOD;
   long           _threshold;
   long           _iterationsValue;
   BOOL           _retrieveHits;
   long           _iterations;
   DKBoolean      _cancel;
   DKBoolean      _isDone;
   DKBoolean      _displayed;
   long           _cnt;
   DKException*   _exc;

   DKSequentialCollection* _pColHitList;

   void displayDDO(int            cnt,
                   DKDatastoreOD* dsOD,
                   DKDDO*         p,
                   DKBoolean      fAfp2Html);
   void displayHit(int cnt, DKDDO* p);

};


#endif
