/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
/************************************************************************/
/*
 * Filename       : TdkDatastore.hpp
 * Description    : FVT/SVT Testing program to test Query String/Objects
 *                  for execute/executeWithCallback/evaluate
 *
 * Change History
 * Date        Name  Description     
 * ----------  ----- -----------------------------------------------------
 * 2000/07/15  CSP   created
 *------------------------------------------------------------------------
 */

#ifndef  _TDKDATASTORE_HPP_
#define  _TDKDATASTORE_HPP_

#include "TLogUtils.hpp"
#include "TdkCallback.hpp"

#define SH_DB_UNKNOWN             0
#define SH_DB_DD                  1
#define SH_DB_DL                  2
#define SH_DB_FED                 3
#define SH_DB_IP                  4
#define SH_DB_JDBC                5
#define SH_DB_OD                  6
#define SH_DB_QBIC                7
#define SH_DB_TS                  8
#define SH_DB_V4                  9

#define CALLBACK_WAIT_TIME_SECS  10

class DKEXPORT TdkDatastore : public TLogUtils
{
  public:
		TdkDatastore();
		virtual ~TdkDatastore();

		virtual void   connect(int argc, char* args[]);
		virtual void   disconnect();

		void           setdkDatastore(dkDatastore* adkDatastore);
		void           setdkDatastore(const DKString& aDBType);
		dkDatastore*   getdkDatastore();
		const DKString getdkDatastoreClassName();
		void           listDatastoreInfo();

		virtual void            processCommand(const DKString& aCmd);
		virtual const  DKString  getAvailableCommands();

		short          getDBType();
		void           setDBType(const DKString& aDBType);
		short          getQLType(const DKString& astrQLType);

		TdkCallback*   getTdkCallback();
		void           waitForTdkCallback(TdkCallback* aTdkCallback);

		virtual void   execute(dkQuery* aQuery);
		virtual void   execute(
				const DKString& aQueryString,
				const short     nQLType       = DK_PARAMETRIC_QL_TYPE, 
				const DKNVPair* aParms        = 0);

		virtual void   evaluate(dkQuery* aQuery);
		virtual void   evaluate(
				const DKString& aQueryString,
				const short     nQLType       = DK_PARAMETRIC_QL_TYPE, 
				const DKNVPair* aParms        = 0);

		virtual void   executeWithCallback(dkQuery* aQuery);
		virtual void   executeWithCallback(
				const DKString& aQueryString,
				const short     nQLType       = DK_PARAMETRIC_QL_TYPE, 
				const DKNVPair* aParms        = 0);

		dkQuery*       convertToQuery(int argc, char** args);

	private:
		dkDatastore*   _dkDatastore;
		DKString       _strCurDSName;
		short          _nDBType;
		char           _strDBName[10];
};

#endif
