/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
(c) Copyright IBM Corp. 1998,  2002. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

//*****************************************************************************
// Class Name  = SampleGuiLogonBeanInfo
// Description = SampleGuiLogon bean information
// Author      = AFIC
// Date        = 04/01/1999
//
//*****************************************************************************

import com.ibm.mm.beans.*;
import com.ibm.mm.beans.util.*;

import java.beans.*;
import java.lang.reflect.*;

//*****************************************************************************
// class/interface definition
//*****************************************************************************
/**
 * SampleGuiLogon Bean Information.
 *
 */
public class SampleGuiLogonBeanInfo extends SimpleBeanInfo {

    /**
    * Get CBConnect bean property descriptors.
    *
    * @return    property descriptors
    */
    public PropertyDescriptor[] getPropertyDescriptors() {
        try {
            PropertyDescriptor pd[] = new PropertyDescriptor[10];

            pd[0] = new PropertyDescriptor("userid", SampleGuiLogon.class);
            pd[0].setDisplayName("User ID");

            pd[1] = new PropertyDescriptor("password", SampleGuiLogon.class);
            pd[1].setDisplayName("Password");

            pd[2] = new PropertyDescriptor("windowTitle", SampleGuiLogon.class);
            pd[2].setDisplayName("Window Title");

            pd[3] = new PropertyDescriptor("useridLabel", SampleGuiLogon.class);
            pd[3].setDisplayName("User ID Field Label");

            pd[4] = new PropertyDescriptor("passwordLabel", SampleGuiLogon.class);
            pd[4].setDisplayName("Password Field Label");

            pd[5] = new PropertyDescriptor("closeLabel", SampleGuiLogon.class);
            pd[5].setDisplayName("Close Button Label");

            pd[6] = new PropertyDescriptor("connectLabel", SampleGuiLogon.class);
            pd[6].setDisplayName("Connect Button Label");

            pd[7] = new PropertyDescriptor("disconnectLabel", SampleGuiLogon.class);
            pd[7].setDisplayName("Disconnect Button Label");

            pd[8] = new PropertyDescriptor("cancelLabel", SampleGuiLogon.class);
            pd[8].setDisplayName("Cancel Connect Button Label");

            pd[9] = new PropertyDescriptor("lookAndFeelStyle", SampleGuiLogon.class);
            pd[9].setDisplayName("GUI Look An Feel Style");
            pd[9].setPropertyEditorClass(com.ibm.mm.beans.util.LookAndFeelStyleEditor.class);

            return pd;
        } catch (IntrospectionException e) {
            e.printStackTrace(); // OK to print on std err, because
            return null; // it only happens during design
        } // time, and if happens, must fix
    }

    /**
    * Get SampleGuiLogon bean event set descriptors.
    *
    * @return    event set descriptors
    */
    public EventSetDescriptor[] getEventSetDescriptors() {
        try {
            EventSetDescriptor ed[] = new EventSetDescriptor[3];

            ed[0] =
                new EventSetDescriptor(
                    SampleGuiLogon.class,
                    "CMBConnectionRequest",
                    CMBConnectionRequestListener.class,
                    "onCMBConnectionRequest");

            ed[1] = new EventSetDescriptor(SampleGuiLogon.class, "vetoableChange", VetoableChangeListener.class, "vetoableChange");

            ed[2] = new EventSetDescriptor(SampleGuiLogon.class, "propertyChange", PropertyChangeListener.class, "propertyChange");

            return ed;
        } catch (IntrospectionException e) {
            e.printStackTrace(); // OK to print on std err, because
            return null; // it only happens during design
        } // time, and if happens, must fix
    }

    /**
    * Get SampleGuiLogon bean descriptor.
    * @return    bean descriptor
    */
    public BeanDescriptor getBeanDescriptor() {
        return new BeanDescriptor(SampleGuiLogon.class); // no customizer
    }

    /**
     * Gets the bean class.
     * @return java.lang.Class
     */
    public static java.lang.Class getBeanClass() {
        return SampleGuiLogon.class;
    }

    /**
     *  Gets the icon for this bean.
     *  It returns an image object that can be used to represent
     *  the bean in toolboxes, toolbars, etc. Icon images will
     *  typically be GIFs, but may in future include other formats.
     *  <p>
     *  There are four possible flavors of icons (16x16 color,
     *  32x32 color, 16x16 mono, 32x32 mono). If a bean choses to only
     *  support a single icon we recommend supporting 16x16 color.
     *
     *  @param iconKind  The kind of icon requested. This should be
     *          one of the constant values ICON_COLOR_16x16,
     *          ICON_COLOR_32x32, ICON_MONO_16x16, or ICON_MONO_32x32.
     */
    public java.awt.Image getIcon(int iconKind) {
        java.awt.Image image = null;
        if (iconKind == java.beans.BeanInfo.ICON_COLOR_16x16) {
            image = loadImage("samples.gif");
        };
        return image;
    }

    //*****************************************************************************
    // private data
    //*****************************************************************************

    //*****************************************************************************
    // Copyright
    //*****************************************************************************
    private static final String ibmid = "5648-D03 and 5648-D04  " + "(C) Copyright IBM Corp. 1994,1999";
}