/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/*
 * Filename       : TDatastorePoolDES.java
 * Description    : test DKDatastorePool for datastore connection pool
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.cs.*;
import java.io.*;
import java.lang.reflect.*;

// TDatastorePoolDES class
public class TDatastorePoolDES implements DKConstantDES {

  public static String Me = new String("TListSubEntitiesDES");
  // Main method
  public static void main(String argv[]){
    
      //*** for input parameters
      String libSrv = new String("");   // libserver
      String userid = new String("");   // userid
      String pw     = new String("");   // pw
      String connect_string     = new String("");  // optional
      String fullClassName = "com.ibm.mm.sdk.server.DKDatastoreDES";

   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

      //-------------------------------------------------------------- 
      // Checking for input parameters
      //-------------------------------------------------------------- 
     
      if (argv.length < 3)
      {
       System.out.println("Usage: " );
       System.out.println("java TDatastorePoolDES " +
        "tcp/ipAddress " +
        "userid " +
        "userpw " +
        "PORT=80;DESAPPID=appid;DESAPPPW=apppw");
       return;
      }
      else
      {
       libSrv = argv[0];
       userid = argv[1];
       pw = argv[2];
       if (argv.length > 3)
          connect_string = argv[3];
      } 
    try {
    DKDatastorePool dsrDES = new DKDatastorePool(fullClassName);
    dsrDES.setDatastoreName(libSrv);
    dsrDES.setMaxPoolSize(10);
    dsrDES.setMinPoolSize(3);
    if (!connect_string.equals(""))
      dsrDES.setConnectString(connect_string);


    dsrDES.initConnections(userid, pw, 2);
    dsrDES.setTimeOut(1); 
    System.out.println(" getMaxPoolSize =  " + dsrDES.getMaxPoolSize());
    System.out.println(" getMinPoolSize =  " + dsrDES.getMinPoolSize());
    System.out.println(" getTimeOut=  " + dsrDES.getTimeOut());

    dkDatastore dsDES1, dsDES2, dsDES3, dsDES4;
    dsDES1 = dsrDES.getConnection(userid, pw);             // new ds1
    System.out.println(" getConnection, dsDES1(ds1) =  " + dsDES1);
    dsDES2 = dsrDES.getConnection(userid, pw);             // new ds2
    System.out.println(" getConnection, dsDES2(ds2) =  " + dsDES2);

    DKDatastoreSession dsIdDES1, dsIdDES2, dsIdDES3, dsIdDES4;
    dsIdDES1 = dsrDES.getConnection(userid, pw, 0);        //new dsid1
    System.out.println(" getConnection, dsIdDES1(dsid1)=" +
     dsIdDES1.getDatastore() + ", sessionId=" + dsIdDES1.getId());
    dsIdDES2 = dsrDES.getConnection(userid, pw, 0);        //new dsid2
    System.out.println(" getConnection, dsIdDES2(dsid2)=" +
     dsIdDES2.getDatastore() + ", sessionId=" + dsIdDES2.getId()); 

    dsrDES.returnConnection(dsIdDES2);                     //dsid2 in _freeIdPool
    System.out.println(" returnConnection, dsIdDES2(dsid2) =  " + 
      dsIdDES2.getDatastore() + ", sessionId=" + dsIdDES2.getId());
    dsrDES.returnConnection(dsDES2);                       //ds2 in _freePool
    System.out.println(" returnConnection, dsDES2(ds2) =  " + dsDES2); 

    dsIdDES3 = dsrDES.getConnection(userid, pw, 1); //ds2 in _usedPool
    System.out.println(" getConnection, dsIdDES3(ds2)=" +
     dsIdDES3.getDatastore() + ", sessionId=" + dsIdDES3.getId());
    dsIdDES4 = dsrDES.getConnection(userid, pw, 5); //new dsid3  
    System.out.println(" getConnection, dsIdDES4(dsid3)=" +
     dsIdDES4.getDatastore() + ", sessionId=" + dsIdDES4.getId());


    dsIdDES4 = dsrDES.getConnection(userid, pw, 6); // new dsid4
    System.out.println(" getConnection, dsIdDES4(dsid4)=" +
     dsIdDES4.getDatastore() + ", sessionId=" + dsIdDES4.getId());

    dsDES1 = dsrDES.getConnection(userid, pw);  // new ds3
    System.out.println(" getConnection, dsDES1(ds3) =  " + dsDES1);
    dsDES2 = dsrDES.getConnection(userid, pw);  // new ds4
    System.out.println(" getConnection, dsDES2(ds4) =  " + dsDES2); 

    dsDES3 = dsrDES.getConnection(userid, pw);  // new ds5
    System.out.println(" getConnection, dsDES3(ds5) =  " + dsDES3);
    dsDES4 = dsrDES.getConnection(userid, pw);  // new ds6
    System.out.println(" getConnection, dsDES4(ds6) =  " + dsDES4); 


    dsIdDES3 = dsrDES.getConnection(userid, pw, 9); // dsid2 
    System.out.println(" getConnection, dsIdDES3(dsid2)=" +
     dsIdDES3.getDatastore() + ", sessionId=" + dsIdDES3.getId());


    //**** use dsDES2 to do ListCatalog
    System.out.println("||**** start: use dsDES2 to do ListCatalog ****||");       
     DKSequentialCollection pCol = null;
     dkIterator pIter = null;
     DKSequentialCollection pCol2 = null;
     dkIterator pIter2 = null;
     DKServerDefDES pSV = null;
     String strServerName = null;
     String strServerType = null;
     String strDatabase = null;
     DKDatabaseDefDES dbDef = null;
     DKFieldDefDES attrDef = null;
     int i = 0;
     int j = 0;    
     System.out.println("list servers");
     pCol = (DKSequentialCollection)dsDES2.listDataSources();
     pIter = pCol.createIterator();
     while (pIter.more() == true)
     {
      i++;
      pSV = (DKServerDefDES)pIter.next();
      strServerName = pSV.getName();
      System.out.println("Server Name [" + i + "] - " + strServerName);
     }
     System.out.println(i + " servers listed");
     System.out.println("list DES databases");
     pCol = (DKSequentialCollection) dsDES2.listEntities();
     pIter = pCol.createIterator();
     i = 0;
     while (pIter.more() == true)
     {
      i++;
      dbDef = (DKDatabaseDefDES)pIter.next();
      strDatabase = dbDef.getName();
//     if (!strDatabase.equals("DB2Example.SBTITEMS"))
//       continue;
      System.out.println("database name [" + i + "] - " + strDatabase);
      System.out.println("  list attributes for " + strDatabase + " database");
      pCol2 = (DKSequentialCollection) dsDES2.listEntityAttrs(strDatabase);
      pIter2 = pCol2.createIterator();
      j = 0;
      while (pIter2.more() == true)
      {
       j++;
       attrDef = (DKFieldDefDES)pIter2.next();
       System.out.println("    Attribute name [" + j + "] - " + attrDef.getName());
       System.out.println("      datastoreType " + attrDef.datastoreType());
       System.out.println("      attributeOf " + attrDef.getEntityName());
       System.out.println("      type " + attrDef.getType());
       System.out.println("      size " + attrDef.getSize());
       System.out.println("      id " + attrDef.getId());
       System.out.println("      nullable " + attrDef.isNullable());
       System.out.println("      precision " + attrDef.getPrecision());
       System.out.println("      scale " + attrDef.getScale());
       System.out.println("      stringType " + attrDef.getStringType());
       System.out.println("      queryable " + attrDef.isQueryable());
       System.out.println("      displayName " + attrDef.getDisplayName());
       System.out.println("      helpText " + attrDef.getHelpText());
       System.out.println("      language " + attrDef.getLanguage());
       System.out.println("      valueCount " + attrDef.getNumVals());
      }
      System.out.println("  " + j + " attributes listed for " + strDatabase + " database");
     }
     System.out.println(i + " databases listed");
    System.out.println("||**** end: use dsDES2 to do ListCatalog ****||");
    //****end of use dsDES2 to do ListCatalog

    dsrDES.returnConnection(dsDES2);
    System.out.println(" returnConnection, dsDES2(ds4) =  " + dsDES2);
    dsDES4 = dsrDES.getConnection(userid, pw);
    System.out.print(" getConnection, dsDES4 =  " + dsDES4); 
    System.out.println("    dsDES4 == dsDES2 =  " + (dsDES4 == dsDES2)); //true

    //**** you can add codes to use dsDES4 to do other thing here  
    //**** end of use dsDES4 to do other thing
       
    dsrDES.returnConnection(dsDES1);
    System.out.println(" returnConnection, dsDES1(ds3) =  " + dsDES1);
    dsrDES.returnConnection(dsDES3);
    System.out.println(" returnConnection, dsDES3(ds5) =  " + dsDES3);
    dsrDES.returnConnection(dsIdDES4); //dsid4 in _freeIdPool
    System.out.println(" returnConnection, dsIdDES4(dsid4) =  " + 
      dsIdDES4.getDatastore() + ", sessionId=" + dsIdDES4.getId());
     

    System.out.println("**** start sleep for 120050 mini sec*******");
    Thread.sleep(120050);  //the two in freePool will be disconnected
    System.out.println("**** end sleep for 120050 mini sec*******");

    dsDES2 = dsrDES.getConnection(userid, pw);     //new ds7
    System.out.println(" getConnection, dsDES2(ds7) =  " + dsDES2); 
    System.out.println(" call destroy()..." );
    dsrDES.destroy();  //take a while for all 4 in usedPool to be disconnected

    }
    catch (DKException exc)
    {
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

  }
}

