//
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
//


// sample connect/disconnect to DES

/*
 * Filename       : TListCategoryAndEntityDES.java
 * Description    : test DKDatastoreDES for connect and disconnect
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;
import java.util.*;

//  TListCategoryAndEntityDES class
public class  TListCategoryAndEntityDES implements DKConstantDES {

  // Main method
  public static void main(String argv[]){

   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

      //--------------------------------------------------------------
      // Checking for input parameters
      //--------------------------------------------------------------
      if (argv.length != 4)
      {
       System.out.println("Usage: " );
       System.out.println("java  TListCategoryAndEntityDES " +
        "tcp/ipAddress " +
        "userid " +
        "userpw " +
        "PORT=80;DESAPPID=appid;DESAPPPW=apppw[;DESCFGPATH=<des cfg file>;DESLOCALE=<locale>]");
       return;
      }

   System.out.println(" TListCategoryAndEntityDES");
   System.out.println("");
    DKDatastoreDES dsDES = null;
    try {
    dsDES = new DKDatastoreDES();
    String userName = dsDES.userName();
    String dsName = dsDES.datastoreName();
    System.out.println("user " + userName + " dsName " + dsName);
    System.out.println("connecting to datastore");
    dsDES.connect(argv[0], argv[1], argv[2], argv[3]);
    System.out.println("datastore connected " + argv[0] + " userid - " + argv[1]);
    userName = dsDES.userName();
    dsName = dsDES.datastoreName();
    System.out.println("user " + userName + " dsName " + dsName);

    //System.out.println("calling refreshDESRepositories()" );
    //dsDES.refreshDESRepositories();
    //System.out.println("completed refreshDESRepositories()" );
/*
	String [] src = dsDES.getSourceList();
	if(src != null) {
		for (int i =0; i < src.length; ++i){
			System.out.println("src=" + src[i]);
		}
	}
*/

	String [] cat = dsDES.listEntityCategoryNames();
	if(cat != null){
		for (int i =0; i < cat.length; ++i){
			System.out.println("*cat= " + cat[i]);
			String[] srcs = dsDES.listEntityNamesByCategory(cat[i]);
			if(srcs!=null){
			for(int j=0; j<srcs.length; ++j){
				System.out.println("  **src=  "+srcs[j]);
				System.out.println("   **linkType=  "+ dsDES.getEntitySourceType(srcs[j]));
			        // String[] srcFlds = dsDES.getAttributeNames(srcs[j]);
				// if(srcFlds != null){
					// for(int k=0; k<srcFlds.length; ++k)
				  		// System.out.println("    ***srcFld=  "+srcFlds[k]);
				// }

				DKNVPair[] actions = dsDES.getActions(srcs[j]);
				if(actions != null){
					
					System.out.println("  ** ACTIONS **");
					for(int m=0;m<actions.length;++m){
						System.out.println("  ** Name="+actions[m].getName()+" URL=" +actions[m].getValue());
					}
				}
			}
			}
		}
	}
	String [] fSources = dsDES.listFileSystemEntities();
	System.out.println("***File System Sources");
	if(fSources != null){
		for(int k=0; k<fSources.length; ++k)
		System.out.println("    ***fSources=  "+fSources[k]);
	}
	else
		System.out.println("fsources is NULL!!");


    dsDES.disconnect();
    System.out.println("datastore disconnected");
    userName = dsDES.userName();
    dsName = dsDES.datastoreName();
    System.out.println("user " + userName + " dsName " + dsName);
    dsDES.destroy();
    }
    catch (DKException exc)
    {
     try {
     dsDES.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
     dsDES.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

  }
}

