/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/*
 * Filename       : TDatastorePoolDL.java
 * Description    : test DKDatastorePool for datastore connection pool
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.cs.*;
import java.io.*;
import java.lang.reflect.*;

// TDatastorePoolDL class
public class TDatastorePoolDL implements DKConstantDL {

  // Main method
  public static void main(String argv[]){
    
      //*** for input parameters
      String libSrv = new String(""),   // library server
             userid = new String(""),   // userid 
  	     pw = new String("");       // pw
      String fullClassName = "com.ibm.mm.sdk.server.DKDatastoreDL";

   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

      //-------------------------------------------------------------- 
      // Checking for input parameters
      //-------------------------------------------------------------- 
     
      if (argv.length < 3)
      {
       System.out.println("Usage: " );
       System.out.println("  java TDatastorePoolDL " +
        "<libSrv> <userid> <pw>" );
       return;
      }
      else
      {
       libSrv = argv[0];
       userid = argv[1];
       pw = argv[2];
      } 
    try {
    DKDatastorePool dsrDL = new DKDatastorePool(fullClassName);
    dsrDL.setDatastoreName(libSrv);
    dsrDL.setMaxPoolSize(10);
    dsrDL.setMinPoolSize(3);

    dsrDL.initConnections(userid, pw, 2);
    dsrDL.setTimeOut(1); 
    System.out.println(" getMaxPoolSize =  " + dsrDL.getMaxPoolSize());
    System.out.println(" getMinPoolSize =  " + dsrDL.getMinPoolSize());
    System.out.println(" getTimeOut=  " + dsrDL.getTimeOut());

    dkDatastore dsDL1, dsDL2, dsDL3, dsDL4;
    dsDL1 = dsrDL.getConnection(userid, pw);             // new ds1
    System.out.println(" getConnection, dsDL1(ds1) =  " + dsDL1);
    dsDL2 = dsrDL.getConnection(userid, pw);             // new ds2
    System.out.println(" getConnection, dsDL2(ds2) =  " + dsDL2);

    DKDatastoreSession dsIdDL1, dsIdDL2, dsIdDL3, dsIdDL4;
    dsIdDL1 = dsrDL.getConnection(userid, pw, 0);        //new dsid1
    System.out.println(" getConnection, dsIdDL1(dsid1)=" +
     dsIdDL1.getDatastore() + ", sessionId=" + dsIdDL1.getId());
    dsIdDL2 = dsrDL.getConnection(userid, pw, 0);        //new dsid2
    System.out.println(" getConnection, dsIdDL2(dsid2)=" +
     dsIdDL2.getDatastore() + ", sessionId=" + dsIdDL2.getId()); 

    dsrDL.returnConnection(dsIdDL2);                     //dsid2 in _freeIdPool
    System.out.println(" returnConnection, dsIdDL2(dsid2) =  " + 
      dsIdDL2.getDatastore() + ", sessionId=" + dsIdDL2.getId());
    dsrDL.returnConnection(dsDL2);                       //ds2 in _freePool
    System.out.println(" returnConnection, dsDL2(ds2) =  " + dsDL2); 

    dsIdDL3 = dsrDL.getConnection(userid, pw, 1); //ds2 in _usedPool
    System.out.println(" getConnection, dsIdDL3(ds2)=" +
     dsIdDL3.getDatastore() + ", sessionId=" + dsIdDL3.getId());
    dsIdDL4 = dsrDL.getConnection(userid, pw, 5); //new dsid3  
    System.out.println(" getConnection, dsIdDL4(dsid3)=" +
     dsIdDL4.getDatastore() + ", sessionId=" + dsIdDL4.getId());


    dsIdDL4 = dsrDL.getConnection(userid, pw, 6); // new dsid4
    System.out.println(" getConnection, dsIdDL4(dsid4)=" +
     dsIdDL4.getDatastore() + ", sessionId=" + dsIdDL4.getId());

    dsDL1 = dsrDL.getConnection(userid, pw);  // new ds3
    System.out.println(" getConnection, dsDL1(ds3) =  " + dsDL1);
    dsDL2 = dsrDL.getConnection(userid, pw);  // new ds4
    System.out.println(" getConnection, dsDL2(ds4) =  " + dsDL2); 

    dsDL3 = dsrDL.getConnection(userid, pw);  // new ds5
    System.out.println(" getConnection, dsDL3(ds5) =  " + dsDL3);
    dsDL4 = dsrDL.getConnection(userid, pw);  // new ds6
    System.out.println(" getConnection, dsDL4(ds6) =  " + dsDL4); 


    dsIdDL3 = dsrDL.getConnection(userid, pw, 9); // dsid2 
    System.out.println(" getConnection, dsIdDL3(dsid2)=" +
     dsIdDL3.getDatastore() + ", sessionId=" + dsIdDL3.getId());


    //**** use dsDL2 to do query
/**/
    System.out.println("||**** start: use dsDL2 to do query ****||");
       dkQuery pQry = null;
       DKResults pResults = null;
       DKNVPair parms[] = null;
       String cmd = "SEARCH=(INDEX_CLASS=DLSAMPLE," +
	                     "MAX_RESULTS=5," +
                            "COND=(DLSEARCH_DocType <> NULL));" +
                            "OPTION=(CONTENT= NO;"       +
                                    "TYPE_QUERY=DYNAMIC;" +
                                    "TYPE_FILTER=FOLDERDOC)";
       System.out.println("query string " + cmd);
       System.out.println("create query");
       pQry = dsDL2.createQuery(cmd,DK_PARAMETRIC_QL_TYPE,parms);
       System.out.println("executing query");
       pQry.execute(parms);
       System.out.println("query executed");
       System.out.println("number of results " + pQry.numberOfResults());
       System.out.println("process query results");
       pResults = (DKResults)pQry.result();
       processResults((dkCollection)pResults);
       System.out.println("query results processed");

    System.out.println("||**** end: use dsDL2 to do query ****||");
/**/
    //****end of use dsDL2 to do query 

    dsrDL.returnConnection(dsDL2);
    System.out.println(" returnConnection, dsDL2(ds4) =  " + dsDL2);
    dsDL4 = dsrDL.getConnection(userid, pw);
    System.out.print(" getConnection, dsDL4 =  " + dsDL4); 
    System.out.println("    dsDL4 == dsDL2 =  " + (dsDL4 == dsDL2)); //true

    //**** use dsDL4 to retrieve XDO - need to change the itemId and partId
/**  
    System.out.println("||**** start: use dsDL4 to retrieve XDO ****||");
     int    partId = 1;  
     String itemId = "V02MP2@#TOH9II$O";
     DKBlobDL axdo = new DKBlobDL(dsDL4);
     DKPidXDODL  apid = new DKPidXDODL();
     apid.setPartId(partId);
     apid.setItemId(itemId);
     axdo.setPidObject(apid);
     System.out.println("itemid=" + apid.getItemId());
     System.out.println("partId=" + apid.getPartId());
     System.out.println("before retrieve......");
     System.out.println("lob length=" + axdo.length());
     System.out.println("size=" + axdo.getSize());
     System.out.println("createdTimestamp=" + axdo.getCreatedTimestamp());
     System.out.println("updatedTimestamp=" + axdo.getUpdatedTimestamp());
   
     System.out.println("about to call retrieve()");
     axdo.retrieve();
     System.out.println("retrieve success...." );
     System.out.println("lob length=" + axdo.length());
     System.out.println("affiliatedTyp=" + axdo.getAffiliatedType());
    System.out.println("||**** end: use dsDL4 to retrieve XDO ****||");
**/
    //****end of use dsDL4 to retrieve XDO
       
    dsrDL.returnConnection(dsDL1);
    System.out.println(" returnConnection, dsDL1(ds3) =  " + dsDL1);
    dsrDL.returnConnection(dsDL3);
    System.out.println(" returnConnection, dsDL3(ds5) =  " + dsDL3);
    dsrDL.returnConnection(dsIdDL4); //dsid4 in _freeIdPool
    System.out.println(" returnConnection, dsIdDL4(dsid4) =  " + 
      dsIdDL4.getDatastore() + ", sessionId=" + dsIdDL4.getId());
     

    System.out.println("**** start sleep for 120050 mini sec*******");
    Thread.sleep(120050);  //the two in freePool will be disconnected
    System.out.println("**** end sleep for 120050 mini sec*******");

    dsDL2 = dsrDL.getConnection(userid, pw);     //new ds7
    System.out.println(" getConnection, dsDL2(ds7) =  " + dsDL2); 
    System.out.println(" call destroy()..." );
    dsrDL.destroy();  //take a while for all 4 in usedPool to be disconnected

    }
    catch (DKException exc)
    {
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

  }

  public static void processResults(dkCollection results) 
                throws DKException, Exception
  {
    Short    sVal;
    short    itemType = 0;
    DKDDO    item = null;
    short    i = 0;
    String   dataName;
    DKParts  parts = null;
    DKFolder folder = null;
    System.out.println( "number of items " + results.cardinality());
 
    dkIterator iter = results.createIterator();
 
    while(iter.more()) {
       item = (DKDDO) iter.next();
       if (item != null) {
   	  item.retrieve();
   	  sVal = (Short)item.getPropertyByName(DK_PROPERTY_ITEM_TYPE);
   	  itemType = sVal.shortValue();
   	  switch(itemType) {
   	    case DK_DOCUMENT:
   	      System.out.println(" Item is a document, number of data item : " + item.dataCount());
   	      for (i = 1; i <= item.dataCount(); i++) {
   		   dataName = item.getDataName(i);
   		   System.out.println("    data-item[" + i + "] = " + dataName + ", value " + item.getData(i));
   		   if (dataName.equals(DKPARTS) == true) {
   		       parts = (DKParts)item.getData(i);
   		       if (parts != null) 
			   System.out.println("   this document has " + parts.cardinality() + " parts ");
   		   }
   	      }
   	      break;
   	    case DK_FOLDER:
   	      System.out.println(" Item is a folder,    number of data item : " + item.dataCount());
   	      for (i = 1; i <= item.dataCount(); i++) {
   		  dataName = item.getDataName(i);
   		  System.out.println("    data-item[" + i + "] = " + dataName + ", value " + item.getData(i));
   		  if (dataName.equals(DKPARTS) == true) {
   		      parts = (DKParts)item.getData(i);
   		      if (parts != null) 
   			 System.out.println("   this folder has " + parts.cardinality() + " parts ");
   		  }
   		  if (dataName.equals(DKFOLDER) == true) {
   		      folder = (DKFolder)item.getData(i);
   		      System.out.println("   this folder has " + folder.cardinality() + " documents ");
   		  }  
   	      }
   	      if (folder != null && folder.cardinality() > 0) {
   		  System.out.println("     --------- list of folder contents --------  ");
   		  processResults(folder);
   		  System.out.println("     ----------- end of list ------------------ ");
   	      }
   	      else System.out.println("  empty folder ");
   	      break;
   	    case DK_WORKBASKET:
   	      System.out.println("  Item is a workbasket ");
   	      break;
   	    case DK_WORKFLOW:
   	      System.out.println("  Item is a workflow ");
   	      break;
   	    default:
   	      System.out.println("  Item is not recognized ");
   	      break;
   	  } 
       }
    } 
  }
}

