/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/********************************************************
 * txdoCRUDDL.java - test the xdo CRUD and open.
 * (the default open handler is "iexplore", the directory
 *  where the iexplore is should be in the PATH.  If
 *  the retrieved file is a text file then set the open	
 *  handler to "notepad".  This test case will run in	
 *  Window NT, for AIX you need to set open handler to "xv".
 ********************************************************/
import com.ibm.mm.sdk.server.*;
import com.ibm.mm.sdk.common.*;
import java.io.*;
import java.lang.*;

public class txdoCRUDDL 
    implements DKConstantDL
{
  //replace following with your library server name, userid, pasword
  public static final String STR_LIB_SERVER  = "LIBSRVRN";
  public static final String STR_USER_ID     = "FRNADMIN";
  public static final String STR_PASSWORD    = "PASSWORD";

  // Main method
  public static void main(String args[])
  {
    // Indicate this is a Console Application on Windows NT/95 for error
    // message display in dos console code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_CM_SS_WINDOWS is the default.
    DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

    //== Following default partId and itemId will be provided if you
    //== run this test case without parameters, If you know existing
    //== partId and itemId, invoke: java txdoCRUDDL <partId> <itemId>
    //== int      partId = 17;  
    //== String   itemId = "R4BEI096O5GM3DDB";
    //==   
    //== Following fileName will be used for add a new part object,
    //== It must exist in the same directory, change the fileName
    //== if you want to add other file
    //== String   fileName = "choice.gif";
    //==   
    //== Following fileName will be used for update the part object,
    //== It must exist in the same directory, change the fileName
    //== if you want to update with other file
    //== fileName = "cheetah.gif";


    int     partId = 17;
    String itemId = "K5#NLPETZ#TU2D$2";
    String fileName = "choice.gif";

    if (args.length == 2)
    {
      partId = (int)Integer.parseInt(args[0], 10);
      itemId = args[1];
      System.out.println("You enter: java txdoCRUDDL " +
       + partId + " " + itemId);
    }
    if (args.length == 1)
    {
      partId =(int)Integer.parseInt(args[0], 10);
      System.out.println("You enter: java txdoCRUDDL " + partId );
      System.out.println("The supplied default itemId = " + itemId);
    }
    if (args.length == 0)
    {
      System.out.println("invoke: java txdoCRUDDL <partId> <itemId>");
      System.out.println("No parameter, folldeowing defaults will be provided:");
      System.out.println("     default partId = " + partId);
      System.out.println("     default itemId = " + itemId);
    } 
    
    DKDatastoreDL dsDL = null;
    try {

    //======== connect to Datastore =======================
    dsDL = new DKDatastoreDL();
    System.out.println("connecting to datastore, please wait..."); 
    dsDL.connect(STR_LIB_SERVER, STR_USER_ID, STR_PASSWORD, "");
    System.out.println("Datastore connected"); 
    Integer _iValObj = (Integer)((dsDL.connection()).handle());
    int _iVal = _iValObj.intValue();
    System.out.println("Datastore handle = " + _iVal);
    
    DKBlobDL axdo = new DKBlobDL(dsDL); 
    DKPidXDODL  apid = new DKPidXDODL();
    apid.setPartId(partId);                  //set part Id in PID
    apid.setItemId(itemId);                  //set item Id in PID
    axdo.setPidObject(apid);                 //set PID for the XDO object
    
    System.out.println("repType=" + axdo.getRepType()); 
    System.out.println("objectType=" + axdo.getObjectType());
    System.out.println("itemid=" + axdo.getItemId());
    System.out.println("partId=" + axdo.getPartId());
    
    //====== retrieve the existing part object =============
    System.out.println("about to call retrieve()");
    axdo.retrieve();
    System.out.println("about to do open()...");
    axdo.setInstanceOpenHandler("lviewpro", true);   //use lviewpro in NT
    axdo.open("mine.gif");     //iexplore requires the file extension  

    //====== add a new part object =========================
    //== before add, the content length is the previous object
    System.out.println("before add, content length = " + axdo.length());
    partId = 0;                            //let DL to decide the partId
    fileName = "china.gif";
    apid.setPartId(partId);                //set partId, use the same itemId
    axdo.setPidObject(apid);               //set PID for the XDO object
    axdo.setContentClass(DK_DL_CC_GIF);    //set content class GIF for part object
    axdo.setRepType(DK_DL_REP_NULL);       //set representation type for the part
    axdo.setContentFromClientFile(fileName); //set XDO content from a file
    System.out.println("after set, content length = " + axdo.getContent().length);
    System.out.println("about to do add()...");
    axdo.add();                            //add part object to DL with same itemId
    System.out.println("The added partId(assign by system) = " +
        ((DKPidXDODL)(axdo.getPidObject())).getPartId() );
    System.out.println("After add, do retrieve and open() to verify it is added..");
    axdo.retrieve();
    System.out.println("after add, content length = " + axdo.length());
    axdo.open("mine2.gif");     //iexplore requires the file extension 

    //====== update the added part object ==================
    //== before update, the content length is the same
    System.out.println("before update, content length = " + axdo.getContent().length);
    fileName = "cheetah.gif";                 //update china.gif to cheetah.gif
    axdo.setContentFromClientFile(fileName);  //set XDO content from a file
    System.out.println("about to do update()...");
    axdo.update();  
    System.out.println("After update, do retrieve and open() to verify it is updated..");
    axdo.retrieve();
    System.out.println("after update, content length = " + axdo.getContent().length);
    axdo.open("mine3.gif");     //iexplore requires the file extension 

    //====== delete the added part object ==================
    System.out.println("Delete the above added object from DL datastore...");
    axdo.del();
    System.out.println("delete successfully!");

    //======== disconnect Datastore =======================
    dsDL.disconnect();
    System.out.println("datastore disconnected"); 
    dsDL.destroy();
    } //end of try

    catch (DKException exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }  
  }
}

