/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/


//import java.net.URL;
//import java.sql.*;
import java.lang.*;
import com.ibm.mm.sdk.common.dkSchemaMapping;
import com.ibm.mm.sdk.common.dkAttrMapping;
import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;

class TSchemaMappingRetrieveFed
{
    public static void main(String argv[])
    {
        dkDatastore     _ds;
        dkSchemaMapping _sm;
        dkAttrMapping   _am;
        dkAttrDef       _ad;
        String          _servername;
        String          _servertype;
        String          _fentityname;
        String          _nentityname;

        try {
            _servername = "LIBLAHM";
            _fentityname = "Employee";
            _nentityname = "EmpTable";

            // create federated datastore
            _ds = new DKDatastoreFed();
            _ds.connect("feddb", "KIRK", "pw", "aa");

            //createSchemaMapping();
            _sm = new DKSchemaMappingFed(_ds);
            _sm.setServerName(_servername);
            _sm.setMappedEntityName(_fentityname);
            _sm.setEntityName(_nentityname);
            _sm.retrieve();

            System.out.println("-- SchemaMapping Name -- " + _sm.getName());
            System.out.println("-- Server Name -- " + _sm.getServerName());
            System.out.println("-- Server Type -- " + _sm.getServerType());
            System.out.println("-- Mapped Entity Name -- " + _sm.getMappedEntityName());
            System.out.println("-- Entity Name -- " + _sm.getEntityName());
            String[] ls = _sm.listAttrMappingNames();
            System.out.println("-- list AttrMapping Name -- ");
            for (int i = 0; i < ls.length; i++)
                System.out.println("    AttrMapping Name" + i + " = " + ls[i]);
            dkCollection col = _sm.listAttrMappings();
            dkIterator iter = col.createIterator();
            System.out.println("-- list AttrMapping -- ");
            while (iter.more())
            {
                _am = (dkAttrMapping)iter.next();
                System.out.println("    ++ AttrMapping Name ++ " +_am.getName());
                System.out.println("    -- To Fucntion -- " + _am.getToNative());
                System.out.println("    -- From Fucntion -- " + _am.getFromNative());
                String[] lm = _am.listMappedAttrNames();
                System.out.println("    -- list Mapped Attr Name -- ");
                for (int i = 0; i < lm.length; i++)
                    System.out.println("        Mapped Attr Name" + i + " = " + lm[i]);
                lm = _am.listMapToAttrNames();
                System.out.println("    -- list MapTo Attr Name -- ");
                for (int i = 0; i < lm.length; i++)
                    System.out.println("        MapTo Attr Name" + i + " = " + lm[i]);
                System.out.println("    -- list Mapped Attr -- ");
                int num = _am.numberOfMappedAttr();
System.out.println("Mapped attr size = " + num);
                for (int i = 0; i < num; i++)
                {
                    _ad = (dkAttrDef)_am.getMappedAttr((short)(i+1));
                    System.out.println("        ++ Mapped Attr Name ++ " +_ad.getName());
                    System.out.println("        -- Mapped Atrr Type -- " +_ad.getType());
                    System.out.println("        -- DataType -- " +_ad.getType());
                    System.out.println("        -- Size -- " +_ad.getSize());
                    System.out.println("        -- Precision -- " +_ad.getPrecision());
                    System.out.println("        -- Scale -- " +_ad.getScale());
                    System.out.println("        -- Max -- " +_ad.getMax());
                    System.out.println("        -- Min -- " +_ad.getMin());
                    System.out.println("        -- Nullable -- " +_ad.isNullable());
                }
                System.out.println("    -- list MapTo Attr -- ");
                num = _am.numberOfMapToAttr();
System.out.println("MapTo attr size = " + num);
                for (int i = 0; i < num; i++)
                {
                    _ad = (dkAttrDef)_am.getMapToAttr((short)(i+1));
                    System.out.println("        ++ MapTo Attr Name ++ " +_ad.getName());
                    System.out.println("        -- MapTo Atrr Type -- " +_ad.getType());
                    System.out.println("        -- DataType -- " +_ad.getType());
                    System.out.println("        -- Size -- " +_ad.getSize());
                    System.out.println("        -- Precision -- " +_ad.getPrecision());
                    System.out.println("        -- Scale -- " +_ad.getScale());
                    System.out.println("        -- Max -- " +_ad.getMax());
                    System.out.println("        -- Min -- " +_ad.getMin());
                    System.out.println("        -- Searchable -- " +_ad.isQueryable());
                }

            }
            _ds.disconnect();
            _ds.destroy();

        }
        catch (java.lang.Exception ex)
        {
            ex.printStackTrace();
        }
    }
}
