/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

// sample connect/disconnect to VI400

/*
 * Filename       : TConnectV4.java
 * Description    : test DKDatastoreV4 for connect and disconnect methods
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

// TConnectV4 class
public class TConnectV4 implements DKConstant
{
  // Main method
  public static void main(String argv[])
  {
    // Indicate this is a Console Application on Windows NT/95 for error
    // message display in dos console code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_CM_SS_WINDOWS is the default.
    DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);
  
    //*** for input parameters
      
    String libSrv = new String(""),     // library server
           userid = new String(""),     // userid 
           pw = new String("");         // pw

    //-------------------------------------------------------------- 
    // Checking for input parameters
    //-------------------------------------------------------------- 
    if (argv.length < 3)
    {
      System.out.println("Invoke Syntax: " );
      System.out.println("  java TConnectV4 " +
                         "<libSrv> <userid> <pw>" );
      return;
    }
    else
    {
      libSrv = argv[0];
      userid = argv[1];
      pw = argv[2];
    } 
    
    DKDatastoreV4 dsV4 = null;
      
    try 
    {
      dsV4 = new DKDatastoreV4();
      String userName = dsV4.userName();
      String dsName = dsV4.datastoreName();
      System.out.println("before connecting to datastore"); 
      System.out.println("  parameters returned from datastore - user: " + 
                         userName + "; library server: " + dsName);   
      System.out.println("connecting to datastore ...");
      dsV4.connect(libSrv,userid,pw,"");
      System.out.println("  connection ok"); 
      System.out.println("  verifying parameters ..."); 
      System.out.println("    arguments received from command    - user: " + 
                         userid + "; library server: " + libSrv); 
      userName = dsV4.userName();
      dsName = dsV4.datastoreName();
      System.out.println("    parameters returned from datastore - user: " + 
                         userName + "; library server: " + dsName);   
      System.out.println("disconnecting from the datastore ..."); 
      dsV4.disconnect();
      userName = dsV4.userName();
      dsName = dsV4.datastoreName();
      System.out.println("  disconnection ok");
      System.out.println("  parameters returned from datastore - user: " + 
                         userName + "; library server: " + dsName);   
    }
    catch (DKException exc)
    {
      System.out.println("Exception name: " + exc.name());
      System.out.println("Exception message: " + exc.getMessage());
      exc.printStackTrace();
    }
    catch (Exception exc)
    {
      System.out.println("Exception message: " + exc.getMessage());
      exc.printStackTrace();
    }

  }
}

