<!--
@copyright(disclaimer)
Licensed Materials - Property of IBM
IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
(c) Copyright IBM Corp. 1998,  2002. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
-->

<%--
  viewtoolbar.jsp: This JSP displays a toolbar that can be used to modify
  the viewing properties of the current page and to navigate from page to page.
  It is embedded within the frames created by viewframe.jsp.
--%>

<%@ page info="toolbar for document viewer"
         language="java"
         import="com.ibm.mm.beans.*,
                 com.ibm.mm.viewer.*,
                 java.net.URLEncoder" 
         session="true"
         buffer="8kb"
         autoFlush="true"
         isThreadSafe="true"
         errorPage="error.jsp"
         isErrorPage="false"
         contentType="text/html; charset=iso-8859-1" %>
<jsp:useBean id="idtodocmap" type="java.util.Hashtable" scope="session"/>

<%!
    // Utility method to construct an appropriate invocation of viewframe.jsp
    String viewPageURL(String itemId, int page, boolean annotations, double scale, int rotation) {
        return "CMBControlServlet"
                +"?reply="+URLEncoder.encode("/jsp/servlets/viewframe.jsp")
                +"&itemId="+URLEncoder.encode(itemId)
                +"&page="+String.valueOf(page)
                +"&scale="+URLEncoder.encode(String.valueOf(scale))
                +"&rotation="+String.valueOf(rotation)
                +"&annotations="+String.valueOf(annotations);
    }
%>
<%
    // get connection
    CMBConnection connection = (CMBConnection) session.getAttribute("connection");
    if ((connection == null) || !connection.isConnected()) {
        throw new RuntimeException("You are not currently logged on.");
    }

    // This logic determines the enablement of the toolbar buttons and the URLs to be used
    // to invoke the JSPs that perform the actions of the toolbar.  These values are placed
    // in the variables below and then referenced in the HTML.
    boolean annotations = true;
    int pageCount = 0;
    int currentPage = 1;
    double currentScale = 1.0;
    int rotation = 0;
    boolean annotationsEnabled = false;
    boolean zoomInEnabled = false;
    boolean zoomOutEnabled = false;
    boolean rotateEnabled = false;
    boolean firstPageEnabled = false;
    boolean previousPageEnabled = false;
    boolean nextPageEnabled = false;
    boolean lastPageEnabled = false;
    String annotURL = "";
    String annotImage = "images/icoHideAnn.gif";
    String annotTip = "Hide Annotations";
    String zoomInURL = "";
    String zoomOutURL = "";
    String rotateLeftURL = "";
    String rotateRightURL = "";
    String rotateDownURL = "";
    String firstPageURL = "";
    String previousPageURL = "";
    String nextPageURL = "";
    String lastPageURL = "";

    double scaleFactor = 1.5; // amount to scale by when zooming in or out

    // Only enable if a document is specified
    String itemId = request.getParameter("itemId");
    if (itemId == null) {
        throw new RuntimeException("The itemId parameter is missing");
    }

    if (idtodocmap == null) {
        throw new RuntimeException("Server error.");
    }

    // Set options according to values in CMBDocument and CMBPage for current page
    CMBDocument document = (CMBDocument) idtodocmap.get(itemId);
    if (document == null) {
      throw new RuntimeException("The itemId specified is not valid.");
    }

    pageCount = document.getPageCount();
    String pageNumberAsString = request.getParameter("page");
    if (pageNumberAsString != null) {
        try {
          currentPage = Integer.decode(pageNumberAsString).intValue();
        } catch (NumberFormatException e) {
          currentPage = 1;
        }
        if (currentPage > pageCount) currentPage = pageCount;
        if (currentPage < 1) currentPage = 1;
    }
    CMBPage ppage = document.getPages(currentPage-1);
    annotations = document.getShowAnnotations() && request.getParameter("annotations").equalsIgnoreCase("yes");
    String scale = request.getParameter("scale");
    if (scale == null || scale.length() == 0) {
        currentScale = document.getPreferredScale();
    } else {
        currentScale = new Double(scale).doubleValue();
    }
    
    rotation = new Integer(request.getParameter("rotation")).intValue();
    //rotation = document.getRotation();

    //String annotation = request.getParameter("annotation");

    annotationsEnabled = document.getCanShowAnnotations();
    zoomInEnabled = currentScale*scaleFactor <= ppage.getMaxScale();
    zoomOutEnabled = currentScale/scaleFactor >= ppage.getMinScale();
    rotateEnabled = document.getCanRotate();
    firstPageEnabled = currentPage > 1;
    previousPageEnabled = currentPage > 1;
    nextPageEnabled = currentPage < pageCount;
    lastPageEnabled = currentPage < pageCount;
    annotURL = viewPageURL(itemId,currentPage,annotations,currentScale,rotation);
    if (annotations) {
      annotImage = "images/icoHideAnn.gif";
      annotTip = "Hide Annotations";
    } else {
      annotImage = "images/icoShowAnn.gif";
      annotTip = "Show Annotations";
    }
    zoomInURL = response.encodeURL(viewPageURL(itemId,currentPage,annotations,currentScale*scaleFactor,rotation));
    zoomOutURL = response.encodeURL(viewPageURL(itemId,currentPage,annotations,currentScale/scaleFactor,rotation));
    rotateLeftURL = response.encodeURL(viewPageURL(itemId,currentPage,annotations,currentScale,(rotation+3)%4));
    rotateRightURL = response.encodeURL(viewPageURL(itemId,currentPage,annotations,currentScale,(rotation+1)%4));
    rotateDownURL = response.encodeURL(viewPageURL(itemId,currentPage,annotations,currentScale,(rotation+2)%4));
    firstPageURL = response.encodeURL(viewPageURL(itemId,1,annotations,currentScale,rotation));
    previousPageURL = response.encodeURL(viewPageURL(itemId,currentPage-1,annotations,currentScale,rotation));
    nextPageURL = response.encodeURL(viewPageURL(itemId,currentPage+1,annotations,currentScale,rotation));
    lastPageURL = response.encodeURL(viewPageURL(itemId,pageCount,annotations,currentScale,rotation));
  
%>

<html>

<head>
	<title>IBM Enterprise Information Portal Servlets Samples</title>
</head>

<body bgcolor="gray">
<table border=0 align="left" cellpadding=0 cellspacing=0>
<tr valign="top" class="TitleBar">
    <td width="20">
<%      if (annotationsEnabled) { 
            if (annotations) { %>
                <a href="<%= annotURL %>" target="_parent"><img src="images/hide_comments.gif" alt="Hide Annotations" width=20 height=20 border="0" align=left hspace=0 vspace=0></a>
<%          } else { %>
           	<a href="<%= annotURL %>" target="_parent"><img src="images/show_comments.gif" alt="Show Annotations" width=20 height=20 border="0" align=left hspace=0 vspace=0></a>
<%          } 
        } else { %>
       		<img src="images/hide_commentsgrey.gif" alt="<%= annotTip %>"width=20 height=20 border="0" align=left hspace=0 vspace=0>
<%      } %>
    </td>
    <td width="5">
        &nbsp;
    </td>
    <td width="20">
<%      if (zoomInEnabled) { %>
       	    <a href="<%= zoomInURL %>" target="_parent"><img src="images/zoom_in.gif" alt="Zoom In (<%= Math.round(currentScale*scaleFactor*100) %>%)" width=20 height=20 border="0" align=left hspace=0 vspace=0></a>
<%      } else { %>
       	    <img src="images/zoom_ingrey.gif" alt="Zoom In" width=20 height=20 border="0" align=left hspace=0 vspace=0>
<%      } %>
    </td>
    <td width="20">
<%      if (zoomOutEnabled) { %>
       	    <a href="<%= zoomOutURL %>" target="_parent"><img src="images/zoom_out.gif" alt="Zoom Out (<%= Math.round(currentScale/scaleFactor*100) %>%)" width=20 height=20 border="0" align=left hspace=0 vspace=0></a>
<%      } else { %>
       	    <img src="images/zoom_outgrey.gif" alt="Zoom Out" width=20 height=20 border="0" align=left hspace=0 vspace=0>
<%      } %>
    </td>
    <td width="5">
        &nbsp;
    </td>
    <td width="20">
<%      if (rotateEnabled) { %>
            <a href="<%= rotateLeftURL %>" target="_parent"><img src="images/rotate_CCW.gif" alt="Rotate Left" width=20 height=20 border="0" align=left hspace=0 vspace=0></a>
<%      } else { %>
	    <img src="images/rotate_CCWgrey.gif" alt="Rotate Left" width=20 height=20 border="0" align=left hspace=0 vspace=0>
<%      } %>
    </td>
    <td width="20">
<%      if (rotateEnabled) { %>
       	    <a href="<%= rotateRightURL %>" target="_parent"><img src="images/rotate_CW.gif" alt="Rotate Right" width=20 height=20 border="0" align=left hspace=0 vspace=0></a>
<%      } else { %>
       	    <img src="images/rotate_CWgrey.gif" alt="Rotate Right" width=20 height=20 border="0" align=left hspace=0 vspace=0>
<%      } %>
    </td>
    <TD width="20">
<%      if (rotateEnabled) { %>
            <a href="<%= rotateDownURL %>" target="_parent"><img src="images/rotate_180.gif" alt="Rotate 180" width=20 height=20 border="0" align=left hspace=0 vspace=0></a>
<%      } else { %>
       	    <img src="images/rotate_180grey.gif" alt="Rotate 180" width=20 height=20 border="0" align=left hspace=0 vspace=0>
<%      } %>
    </td>
    <TD width="5">
        &nbsp;
    </TD>
    <TD width="20">
<%      if (firstPageEnabled) { %>
       	    <a href="<%= firstPageURL %>" target="_parent"><img src="images/Firstblack.gif" alt="First Page" width=20 height=20 border="0" align=left hspace=0 vspace=0></a>
<%      } else { %>
            <img src="images/Firstgrey.gif" alt="First Page" width=20 height=20 border="0" align=left hspace=0 vspace=0>
<%      } %>
    </td>
    <TD width="20">
<%      if (previousPageEnabled) { %>
       	    <a href="<%= previousPageURL %>" target="_parent"><img src="images/Previousblack.gif" alt="Previous Page" width=20 height=20 border="0" align=left hspace=0 vspace=0></a>
<%      } else { %>
       	    <img src="images/Previousgrey.gif" alt="Previous Page" width=20 height=20 border="0" align=left hspace=0 vspace=0>
<%      } %>
    </td>
    <TD width="20">
<%      if (nextPageEnabled) { %>
            <a href="<%= nextPageURL %>" target="_parent"><img src="images/Nextblack.gif" alt="Next Page" width=20 height=20 border="0" align=left hspace=0 vspace=0></a>
<%      } else { %>
            <img src="images/Nextgrey.gif" alt="Next Page" width=20 height=20 border="0" align=left hspace=0 vspace=0>
<%      } %>
    </td>
    <TD width="20">
<%      if (lastPageEnabled) { %>
            <a href="<%= lastPageURL %>" target="_parent"><img src="images/Lastblack.gif" alt="Last Page" width=20 height=20 border="0" align=left hspace=0 vspace=0></a>
<%      } else { %>
       	    <img src="images/Lastgrey.gif" alt="Last Page" width=20 height=20 border="0" align=left hspace=0 vspace=0>
<%      } %>
    </td>
    <TD width="5">
        &nbsp;
    </TD>
    <form action="CMBControlServlet" method="GET" target="_parent">

    <TD width="125" align="left" valign="top" nowrap>     
        <SELECT name="page" onchange="this.form.submit()">
<%      for (int i=1; i<= pageCount; i++) { 
            if (i == currentPage){ %>
                <OPTION selected value="<%= i %>"><%= i %></OPTION>
<%          } else { %>
	    	<OPTION value="<%= i %>"><%= i %></OPTION>
<%          } 
        } %>
	</SELECT>
	<strong>&nbsp;of <%= pageCount %>&nbsp;&nbsp;</strong>
    </td>
    <TD valign="top" align=right>    				
	<!-- Hidden input fields to transfer values to the jsp -->
	<input type="hidden" name="itemId" value="<%= itemId %>">
	<input type="hidden" name="scale" value="<%= URLEncoder.encode(String.valueOf(currentScale)) %>">
	<input type="hidden" name="rotation" value="<%= URLEncoder.encode(String.valueOf(rotation)) %>">
	<input type="hidden" name="annotations" value="<%= URLEncoder.encode(String.valueOf(annotations)) %>">
        <input type="hidden" name="reply" value="/jsp/servlets/viewframe.jsp">
    </td>
    </form>
</tr>
</table>

</body>

</html>

